//+------------------------------------------------------------------+
//|                                         Moving Average_KimIV.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#define MAGICMA  20050610

#include <stdlib.mqh>  

//extern double Lots               = 0.1;
//extern double MaximumRisk        = 0.02;
//extern double DecreaseFactor     = 3;
extern double MovingPeriod       = 12;
extern double MovingShift        = 6;

extern int     LotsWayChoice     = 0;     // loto kaiciavimo parinkimas   
                                         //  0-fiksuotas Loto skaiciavimas 
                                        //  1-procentas nuo depozito
                                       //  2-frokciono-proporcinis
                                      //  3-frakcioninis-fiksuotas
extern string  S9                = "Loto skaiciavimo parinkimas";
extern double  Lots              = 0.1;  //   
extern int     LotsPercent       = 10;   //   
extern int     LotsDeltaDepo     = 500;  //   
extern int     LotsDepoForOne    = 500;  //     
extern int     LotsMax           = 1000; //   
         color  clOpenBuy          = LightBlue;      // atidarymo Buy rodykles spalva
       color  clOpenSell         = LightCoral;
       bool    MarketWatch       =true;
       int     Slippage          = 4;
       bool   UseSound           = True;          //   
       extern string symbol             = "";
extern string SoundSuccess       = "expert.wav";  //  
extern string SoundError         = "timeout.wav";
       string NameFileSound      = "expert.wav"; 
       bool gbDisabled        =false;
       int     NumberOfTry       = 1;
int     TimeFrame         =15;       
 int op_signal=0;    
       double ma=0;
//+------------------------------------------------------------------+
//| Globalus kintamieji                                              |
//+------------------------------------------------------------------+                                    
   //******************************
   //Indikatoriu kintamieji
   //******************************
  
     //double SignalPrevious, MaCurrent, MaPrevious;
     //extern double MACDOpenLevel=3;
     //extern double MACDCloseLevel=2;
     //extern double MATrendPeriod=26;
   //******************************
   //Prekybiniu signalu kintamieji
   //******************************
    //bool Signal_OpenBuy;
    //bool Signal_OpenSell;
    //bool Signal_CloseBuy;
    //bool Signal_CloseSell;
    
    
    
    
    
    
    
 //+------------------------------------------------------------------+
//| Vartotojiskos funkcijos                                          |
//+------------------------------------------------------------------+
//*******************************************************************

//+------------------------------------------------------------------+
//| Indikatoriu kintamieji                                           |
//+------------------------------------------------------------------+   
    void Indicat_Var()
{   
   ma=iMA(symbol,TimeFrame,MovingPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,0);
   if(Open[1]> ma && Close[1]<ma)op_signal=OP_BUY;
   if(Open[1]<ma && Close[1]>ma) op_signal=OP_SELL;
   //MacdCurrent    =iMACD(symbol,TimeFrame,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
  // MacdPrevious   =iMACD(symbol,TimeFrame,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   //SignalCurrent  =iMACD(symbol,TimeFrame,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
   //SignalPrevious =iMACD(symbol,TimeFrame,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
   //MaCurrent      =iMA  (symbol,TimeFrame,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,0);
   //MaPrevious     =iMA  (symbol,TimeFrame,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,1);
}
           
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
//double LotsOptimized()
  ///{
   //double lot=Lots;
   //int    orders=HistoryTotal();     // history orders total
   //int    losses=0;                  // number of losses orders without a break
//---- select lot size
   //lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   //if(DecreaseFactor>0)
     //{
      //for(int i=orders-1;i>=0;i--)
        //{
         //if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         //if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         //if(OrderProfit()>0) break;
         //if(OrderProfit()<0) losses++;
        //}
      //if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     //}
//---- return lot size
   //if(lot<0.1) lot=0.1;
   //return(lot);
  //}
  
  double GetSizeLot()
{
  double dLot;
   double ml=MarketInfo(symbol, MODE_MINLOT);
   double mx=MarketInfo(symbol, MODE_MAXLOT);
   
  if (LotsWayChoice==0) dLot=Lots;

  // fiksuotas procentas nuo depozito
  if (LotsWayChoice==1)
  {
    dLot=MathCeil(AccountFreeMargin()/10000*LotsPercent)/10;
  }

  // frakcioninis-proporcinis
  if (LotsWayChoice==2)
  {
    int k=LotsDepoForOne;
    for (double i=2; i<=LotsMax; i++)
    {
      k=k+i*LotsDeltaDepo;
      if (k>AccountFreeMargin())
      {
        dLot=(i-1)/10; break;
      }
    }
  }

  // frokcioninis-fikuotas
  if (LotsWayChoice==3)
  {
    dLot=MathCeil((AccountFreeMargin()-LotsDepoForOne)/LotsDeltaDepo)/10;
  }

  if (dLot<ml) dLot=ml;
  return(dLot);
}
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   //double ma;
   int    res;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average 
   //ma=iMA(NULL,0,MovingPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,0);
   Indicat_Var();
//---- sell conditions
   //if(Open[1]> && Close[1]<ma)
   if(op_signal==OP_BUY)  
     {
      //res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,0,0,"",MAGICMA,0,Red);
      //OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0, string co="")
      OpenPosition(Symbol(),OP_SELL,GetSizeLot(), 0, 0,MAGICMA,""); 
      return;
     }
//---- buy conditions
   //if(Open[1]<ma && Close[1]>ma) 
   if(op_signal==OP_SELL) 
     {
      //res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,0,0,"",MAGICMA,0,Blue);
      //OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0, string co="")
      OpenPosition(Symbol(),OP_SELL,GetSizeLot(), 0, 0,MAGICMA,""); 
      return;
     }
//----
  }
  //+------------------------------------------------------------------+
//| OpenPosition                                |
//+------------------------------------------------------------------+
  void OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0, string co="") 
{
  color    clOpen;
  datetime ot;
  double   pp, pa, pb;
  int      dg, err, it, ticket=0;

  if (sy=="" || sy=="0") sy=Symbol();
  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  if (co=="") co=WindowExpertName()+" "+CorrectTF(Period());
  for (it=1; it<=NumberOfTry; it++) 
  {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) 
	{
      Print("OpenPosition(): funkcijos darbo sustabdymas");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    dg=MarketInfo(sy, MODE_DIGITS);
    pa=MarketInfo(sy, MODE_ASK);
    pb=MarketInfo(sy, MODE_BID);
    if (op==OP_BUY) pp=pa; else pp=pb;
    pp=NormalizeDouble(pp, dg);
    ot=TimeCurrent();
    if (MarketWatch)
      ticket=OrderSend(sy, op, ll, pp, Slippage, 0, 0, co, mn, 0, clOpen);
    else
      ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, co, mn, 0, clOpen);
    if (ticket>0) 
	{
      if (UseSound) PlaySound(SoundSuccess); break;
    } 
	else 
	{
      err=GetLastError();
      if (UseSound) PlaySound(SoundError);
      if (pa==0 && pb==0) Message("Patikrinkit ar yra toks simbolis"+sy);
      // Pranesimas apie klaida
      Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa," Bid=",pb," sy=",sy," ll=",ll," op=",GetNameOP(op),
            " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
      // EA darbo blokavimas
      if (err==2 || err==64 || err==65 ||  err==131 || err==133) 
	  {
        gbDisabled=True; break;
      }
      // Ilga pauze
      if (err==4 || err==132) 
	  {
        Sleep(1000*300); break;
      }
      if (err==128 || err==142 || err==143) 
	  {
        Sleep(1000*66.666);
        if (ExistPositions(sy, op, mn, ot)) 
		{
          if (UseSound) PlaySound(SoundSuccess); break;
        }
      }
      if (err==140 || err==148 || err==4110 || err==4111) break;
      if (err==141) Sleep(1000*100);
      if (err==145) Sleep(1000*17);
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      if (err!=135) Sleep(1000*7.7);
    }
  }
  if (MarketWatch && ticket>0 && (sl>0 || tp>0)) {
    if (OrderSelect(ticket, SELECT_BY_TICKET)) ModifyOrder(-1, sl, tp);
  }
}



int CorrectTF(int TimeFrame=0) 
{
  if (TimeFrame==0) TimeFrame=Period();
  if (TimeFrame< PERIOD_M5                         ) return(PERIOD_M1);
  if (TimeFrame>=PERIOD_M5  && TimeFrame<PERIOD_M15) return(PERIOD_M5);
  if (TimeFrame>=PERIOD_M15 && TimeFrame<PERIOD_M30) return(PERIOD_M15);
  if (TimeFrame>=PERIOD_M30 && TimeFrame<PERIOD_H1 ) return(PERIOD_M30);
  if (TimeFrame>=PERIOD_H1  && TimeFrame<PERIOD_H4 ) return(PERIOD_H1);
  if (TimeFrame>=PERIOD_H4  && TimeFrame<PERIOD_D1 ) return(PERIOD_H4);
  if (TimeFrame>=PERIOD_D1  && TimeFrame<PERIOD_W1 ) return(PERIOD_D1);
  if (TimeFrame>=PERIOD_W1  && TimeFrame<PERIOD_MN1) return(PERIOD_W1);
  if (TimeFrame>=PERIOD_MN1                        ) return(PERIOD_MN1);
}



string GetNameOP(int op) 
 {
  switch (op) 
  {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("Buy Limit");
    case OP_SELLLIMIT: return("Sell Limit");
    case OP_BUYSTOP  : return("Buy Stop");
    case OP_SELLSTOP : return("Sell Stop");
    default          : return("Unknown Operation");
  }
}



void ModifyOrder(double pp=-1, double sl=0, double tp=0, color cl=CLR_NONE) 
{
  bool   fm;
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) 
  {
    for (it=1; it<=NumberOfTry; it++) 
	{
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, 0, cl);
      if (fm) 
	  {
        if (UseSound) PlaySound(NameFileSound); break;
      } 
	  else 
	  {
        er=GetLastError();
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);
      }
    }
  }
}



bool ExistPositions(string symbol="", int op=-1, int mn=-1, datetime ot=0) 
{
  int i, k=OrdersTotal();

  if (symbol=="0") symbol=Symbol();
  for (i=0; i<k; i++) 
  {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
	{
      if (OrderSymbol()==symbol || symbol=="") 
	  {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) 
		{
          if (op<0 || OrderType()==op) 
		  {
            if (mn<0 || OrderMagicNumber()==mn) 
			{
              if (ot<=OrderOpenTime()) return(True);
            }
          }
        }
      }
    }
  }
  return(False);
}


void Message(string m) 
{
  Comment(m);
  if (StringLen(m)>0) Print(m);
}
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   //double ma;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average 
   ma=iMA(NULL,0,MovingPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,0);
   //Indicat_Var();                                                 //????????????????????????????????????
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(Open[1]>ma && Close[1]<ma) OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(Open[1]<ma && Close[1]>ma) OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         break;
        }
     }
//----
  }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
//----
  }
//+------------------------------------------------------------------+